<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.processadmin.server.ProcessAdminServicesUtils"%>
<%@ page import="com.lombardisoftware.core.UserLocalePreferences" %>
<%@ page import="java.util.Locale" %>
<%@ page import="com.lombardisoftware.utility.i18n.LocaleUtils" %>
<%
    // Debug locale override.
	String locale = request.getParameter("locale");
	if (locale == null) {

        // If user does not have locale prefs save it to
        UserLocalePreferences userLocalePrefs = ProcessAdminServicesUtils.getCurrentUserLocalePreferences();
        if (userLocalePrefs.isFallback()) {

            Locale matching = LocaleUtils.findMatching(LocaleUtils.getInstalledLocales(), request.getLocales());
            ProcessAdminServicesUtils.setCurrentUserLocalePreferences(matching.toString());
            locale = matching.toString();
        } else {
            // If user has locale pref -- use it and set cookies to it.
            locale = userLocalePrefs.getLocale();
        }
        LocaleUtils.saveLocaleToCookies(locale, response);

	}
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html style="overflow:hidden">
    <head>
        <title>IBM Business Process Manager Process Admin</title>
        <meta http-equiv="X-UA-Compatible" content="IE=8" />
        <meta http-equiv="content-type" content="text/html; charset=UTF-8">
		<% 	if (locale != null) { %>
    	<meta name="gwt:property" content="locale=<%= locale %>"> <%
    		}
    	%>
        <link rel="stylesheet" type="text/css" href="GwtCommon.css" />
        <link rel="stylesheet" type="text/css" href="ProcessAdmin.css" />
        <!--[if IE 6]>
            <link rel="stylesheet" type="text/css" href="ie6processAdmin.css" />
            <script>
                try {
                  document.execCommand("BackgroundImageCache", false, true);
                } catch(err) {}
            </script>
        <![endif]--> 

		<script>
	        function doOnLoad() {
	            try {
		            setCookie("ibm.bpm.timezoneOffset", new Date().getTimezoneOffset(), null, "/",null,<% if(request.isSecure()){%>true<%}else{%>null<%}%>);
			    } catch(ex) {
				    //do nothing
				}
			}

	        function setCookie(name, value, expires, path, domain, secure) {
		        var curCookie = name + "=" + escape(value) +
			            ((expires) ? "; expires=" + expires.toGMTString() : "") +
				        ((path) ? "; path=" + path : "") +
						((domain) ? "; domain=" + domain : "") +
					    ((secure) ? "; secure" : "");
	            document.cookie = curCookie;
		    }
		</script>

    </head>
    <script language="JavaScript" type="text/javascript">
        var wle_gwt_i18n_CommonMessages = <%= ProcessAdminServicesUtils.getClientResourceBundleContent("CommonMessages", locale) %>;
        var wle_gwt_i18n_ProcessAdminMessages = <%= ProcessAdminServicesUtils.getClientResourceBundleContent("ProcessAdminMessages", locale) %>;
        var wle_gwt_i18n_HelpMessages = <%= ProcessAdminServicesUtils.getClientResourceBundleContent("HelpMessages", locale) %>;
        var wle_gwt_i18n_IntegrationCommonMessages = <%= ProcessAdminServicesUtils.getClientResourceBundleContent("IntegrationCommonMessages", locale) %>;
        var wle_gwt_i18n_CommonMessages_default = <%= ProcessAdminServicesUtils.getClientResourceBundleContent("CommonMessages", "en") %>;
        var wle_gwt_i18n_ProcessAdminMessages_default = <%= ProcessAdminServicesUtils.getClientResourceBundleContent("ProcessAdminMessages", "en") %>;
        var wle_gwt_i18n_HelpMessages_default = <%= ProcessAdminServicesUtils.getClientResourceBundleContent("HelpMessages", "en") %>;
        var wle_gwt_i18n_IntegrationCommonMessages_default = <%= ProcessAdminServicesUtils.getClientResourceBundleContent("IntegrationCommonMessages", "en") %>;
    </script>
    <body onLoad="doOnLoad()">
        <script language="javascript" src="com.lombardisoftware.processadmin.ProcessAdmin.nocache.js"></script>
    </body>
</html>
