<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.ibm.processinspector.server.ProcessInspectorServicesUtils"%>
<%@ page import="com.lombardisoftware.core.UserLocalePreferences" %>
<%@ page import="java.util.Locale" %>
<%@ page import="com.lombardisoftware.utility.i18n.LocaleUtils" %>
<%
    // Debug locale override.
    String locale = request.getParameter("locale");
    if (locale == null) {
        // If user does not have locale prefs save it to
        UserLocalePreferences userLocalePrefs = ProcessInspectorServicesUtils.getCurrentUserLocalePreferences();
        if (userLocalePrefs.isFallback()) {
            Locale matching = LocaleUtils.findMatching(LocaleUtils.getInstalledLocales(), request.getLocales());
            ProcessInspectorServicesUtils.setCurrentUserLocalePreferences(matching.toString());
            locale = matching.toString();
        } else {
            // If user has locale pref -- use it and set cookies to it.
            locale = userLocalePrefs.getLocale();
        }
        LocaleUtils.saveLocaleToCookies(locale, response);
    }
%>
<!DOCTYPE html>
<html>
    <head>
        <title>IBM Business Process Manager Process Inspector</title>
        <meta http-equiv="content-type" content="text/html; charset=UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=8" />
		<%
		    if (locale != null) {
		%>
    	<meta name="gwt:property" content="locale=<%=locale%>">
    	<%
			}
		%>
        <link rel="stylesheet" type="text/css" href="GwtCommon.css" />
        <link rel="stylesheet" type="text/css" href="ProcessInspector.css" />
    
    </head>

    <script language="JavaScript" type="text/javascript">
        var wle_gwt_i18n_CommonMessages = <%=ProcessInspectorServicesUtils.getClientResourceBundleContent("CommonMessages", locale)%>;
        var wle_gwt_i18n_ProcessAdminMessages = <%=ProcessInspectorServicesUtils.getClientResourceBundleContent("ProcessAdminMessages", locale)%>;
        var wle_gwt_i18n_ProcessInspectorMessages = <%=ProcessInspectorServicesUtils.getClientResourceBundleContent("ProcessInspectorMessages", locale)%>;
        var wle_gwt_i18n_HelpMessages = <%=ProcessInspectorServicesUtils.getClientResourceBundleContent("HelpMessages", locale)%>;
        var wle_gwt_i18n_CommonMessages_default = <%=ProcessInspectorServicesUtils.getClientResourceBundleContent("CommonMessages", "en")%>;
        var wle_gwt_i18n_ProcessAdminMessages_default = <%=ProcessInspectorServicesUtils.getClientResourceBundleContent("ProcessAdminMessages", "en")%>;
        var wle_gwt_i18n_ProcessInspectorMessages_default = <%=ProcessInspectorServicesUtils.getClientResourceBundleContent("ProcessInspectorMessages", "en")%>;
        var wle_gwt_i18n_HelpMessages_default = <%=ProcessInspectorServicesUtils.getClientResourceBundleContent("HelpMessages", "en")%>;
    </script>
    <body>
        <script language="javascript" src="com.ibm.processinspector.ProcessInspector.nocache.js"></script>
    </body>
</html>
