<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="msgs-init.jsp" %>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<!DOCTYPE html> 
<html> 
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=8" />
<title><bean:message key="title"/></title>
<style type="text/css">
html {
	height: 100%;
	width: 100%;
}
body {
	height: 100%;
	width: 100%;
	margin: 0px;
	color: #131313;
	font-family: Verdana,Arial,Helvetica,sans-serif;
	font-size: 0.688em;
}
.outer_container {
	padding: 5px;
/*	width: 320px; */
	border: 1px solid #C8C7C7;
}
.title {
	border-bottom: thin solid #E9E9EA;
	border-top: medium groove;
	font-size: larger;
	font-weight: bold;
	margin-bottom: 5px;
	margin-top: 5px;
	padding-bottom: 2px;
	padding-top: 2px;
}
.embed_image {
	float: right;
	margin-right: 5px;
	margin-top: 3px;
	cursor: pointer;
}
#dateRange {
	margin: 12px auto;
	text-align: center;
}
.dateRange_all {
	cursor: pointer;
	text-decoration: none;
	color: black;
	padding: 3px 8px;
	border: 2px solid;
	border-color: black;
}
.dateRange_left {
	border-top-left-radius: 10px;
	border-bottom-left-radius: 10px;
	-moz-border-radius-bottomleft: 10px;
	-moz-border-radius-topleft: 10px;
}
.dateRange_right {
	border-top-right-radius: 10px;
	border-bottom-right-radius: 10px;
	-moz-border-radius-bottomright: 10px;
	-moz-border-radius-topright: 10px;
}
.dateRange_no_right_border {
	border-right: 0px;
}
.dateRange_highlight {
	cursor: auto;
	background-color: #e7e7e7;
	font-weight: bold;
}
.status_container {
	margin: 12px auto;
	text-align: center;
}
.status {
	margin: 2px;
	display: inline-block;
	cursor: pointer;
}

* html .status { display:inline; }  /* for IE 6 */
* + html .status { display:inline; }  /* for IE 7 */

.status_value {
	display: inline-block;
	min-width: 40px;
	padding: 5px;
	-webkit-border-radius: 12px;
	-moz-border-radius: 12px;
	border-radius: 12px;
	border: 1px solid;
	font-size: large;
}
#started_value {
	background-color: #009345;
	border-color: #009345;
	color: white;
}
#completed_value {
	background-color: #262261;
	border-color: #262261;
	color: white;
}
#late_value {
	background-color: #FFF100;
	border-color: #FFF100;
	color: black;
}
#executing_value {
	background-color: #F6921E;
	border-color: #F6921E;
	color: white;
}
#failed_value {
	background-color: #EC1C24;
	border-color: #EC1C24;
	color: white;
}
.status_text {
/*	font-size: smaller; */
}
.heading_image {
	float: left;
	margin-right: 5px;
}
.heading {
	font-size: larger;
	margin-bottom: 0;
}
</style>
<%
String portalContextRoot = "/portal";
com.ibm.bpm.crconfig.BPMContextRootConfigService contextRootService = com.ibm.bpm.crconfig.BPMContextRootConfigServiceFactory.getInstance().getContextRootConfigService();
if (contextRootService != null){
	String contextRoot = contextRootService.getContextRoot(com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTALSUPPORT);
	if (contextRoot != null){
        	portalContextRoot = contextRoot;
	}
}
%>

<link rel="stylesheet" type="text/css" href="<%=portalContextRoot%>/js/dojo/1.6.1/dijit/themes/claro/claro.css"/>

<script type="text/javascript">
	// <![CDATA[
	/**
	 * Collapses all text nodes that only contain white space characters into empty string.
	 * Skips certain nodes where whitespace does not impact layout and would cause unnecessary processing.
	 * Similar to features that hopefully will appear in CSS3 via white-space-collapse
	 * 
	 * @param {HTMLElement} element Element whose text nodes should be collapse
	 */
	var skip = {"SCRIPT":1, "STYLE":1},
		collapse = function(element) {
		for (var i = 0; i < element.childNodes.length; i++){
			var cn = element.childNodes[i];
			if (cn.nodeType == 3){    // Text node
				//FIXME: exclusion for SCRIPT, CSS content?
				cn.nodeValue = cn.data.replace(/^[\f\n\r\t\v\ ]+$/g,"");
			}else if (cn.nodeType == 1 && !skip[cn.nodeName]){ // Element node
				collapse(cn);
			}
		}
	};

	var handler = function() {
		if (document.body.getAttribute('white-space-collapse') == 'collapse') {
			collapse(document.body);
		}
	};

	if (document.addEventListener) {
		document.addEventListener("DOMContentLoaded", handler, false);
		window.addEventListener("load", handler, false);
	} else if (window.attachEvent) {
		window.attachEvent("onload", handler);
	}

	djConfig = {};
	djConfig.parseOnLoad = true;
	// uncomment following line when debugging DOJO code
	// djConfig.isDebug = true;
	
	// ]]>
</script>
</head>
<body class="claro" white-space-collapse="collapse">
 <div class="outer_container">
  <div>
   <img class="embed_image" src="embed.png" title="<bean:message key="embed"/>" alt="<bean:message key="embed"/>" onclick="handleEmbedClick(event);">
   <p class="title"><bean:message key="title"/></p>
  </div>

  <div id="dateRange" onclick="handleDateRangeClick(event);">
   <span id="today" class="dateRange_all dateRange_no_right_border dateRange_left dateRange_highlight"><bean:message key="today"/></span>
   <span id="week" class="dateRange_all dateRange_no_right_border"><bean:message key="week"/></span>
   <span id="month" class="dateRange_all dateRange_no_right_border"><bean:message key="month"/></span>
   <span id="year" class="dateRange_all dateRange_no_right_border"><bean:message key="year"/></span>
   <span id="all-time" class="dateRange_all dateRange_right"><bean:message key="alltime"/></span>
  </div>

  <div class="status_container">
   <div id="started" class="status" align="center" onclick="handleStatusClick('active', 'started_value');">
    <div id="started_value" class="status_value">0</div>
    <div id="started_text" class="status_text"><bean:message key="started"/></div>
   </div>
   <div id="competed" class="status" align="center" onclick="handleStatusClick('completed', 'completed_value');">
    <div id="completed_value" class="status_value">0</div>
    <div id="completed_text" class="status_text"><bean:message key="completed"/></div>
   </div>
   <div id="late" class="status" align="center" onclick="handleStatusClick('late', 'late_value');">
    <div id="late_value" class="status_value">0</div>
    <div id="late_text" class="status_text"><bean:message key="late"/></div>
   </div>
   <div id="executing" class="status" align="center" onclick="handleStatusClick('executing', 'executing_value');">
    <div id="executing_value" class="status_value">0</div>
    <div id="executing_text" class="status_text"><bean:message key="executing"/></div>
   </div>
   <div id="failed" class="status" align="center" onclick="handleStatusClick('failed', 'failed_value');">
    <div id="failed_value" class="status_value">0</div>
    <div id="failed_text" class="status_text"><bean:message key="failed"/></div>
   </div>
  </div>

  <div>
   <img class="heading_image" src="process_apps.png" alt=""/>
   <p class="heading"><bean:message key="processApps"/></p>
   <ul id="process_apps_template" style="display: none; margin-top: 0; list-style: none;">
    <li style="padding: 0px 0px 0px 22px; margin-top: 4px; margin-left: -22px;"><a href="#">Name</a></li>
   </ul>
   <ul id="empty_list" style="margin-top: 0;">
   </ul>
  </div>

  <div id="open_inspector" style="visibility: hidden">
   <img class="heading_image" src="magnifying_glass.png" alt=""/>
   <p class="heading"><a href="javascript:void(0)" onclick="launchInspector(duration,null,null);"><bean:message key="openProcessInspector"/></a></p>
  </div>
 </div>

 <script src="<%=portalContextRoot%>/js/dojo/1.6.1/dojo/dojo.js.uncompressed.js" type="text/javascript"></script>
<script type="text/javascript">
	var duration = "today";
	var isProcessAdminMode = false;
	var params = location.search;
	if (!!params && params.length > 0) {
		params = params.substring(1, params.length);
		var value = dojo.queryToObject(params).embedded;
		if (value=="false") {
			isProcessAdminMode = true;
		}
	}
	
	if (!isProcessAdminMode) {
		// show open inspector link
		var elem = dojo.byId("open_inspector");
		dojo.style(elem, "visibility", "visible");
	}

	function handleDateRangeClick(e) {
		//If "e" is undefined use the global "event" variable
		e = e || event;

		var target = e.srcElement || e.target;
		handleDateRange(target.id);
		duration = target.id;
	}

	function handleEmbedClick(e) {
		dojo.require("dijit.Dialog");

		var embedTitle = "<bean:message key="embedTitle"/>";
		var embedDlg = new dijit.Dialog({
			title: embedTitle,
			style: "width: 370px"
		});
		var url = location.protocol + "//" + location.host + location.pathname;
		embedDlg.attr("content", '<p style="font-family: monospace; font-size: small; margin: 0px; word-wrap: break-word;">&lt;iframe src="' + url + '" frameborder="0" style="border: medium none; height: 300px; width: 400px;"&gt;&lt;/iframe&gt;</p>');
		embedDlg.show();
	}

	function handleStatusClick(status, elementId) {
		launchInspector(duration, status);
	}
	
	function launchInspector(duration, status, processApp) {
		if (isProcessAdminMode) {
			window.parent.parent.showProcessInspector(duration, status, processApp);
		} else {
			var url = "../ProcessInspector/com.ibm.processinspector.ProcessInspector/ProcessInspector.jsp?";
			if (duration != null) {
				url += "duration=" + duration;
			}
			if (status != null) {
				if( url.substr(-1) != "?" ) {
					url += "&";
				}
				url += "status=" + status;
			}
			if (processApp != null) {
				if( url.substr(-1) != "?" ) {
					url += "&";
				}
				url += "processApp=" + processApp;
			}
			
			if (window != top) {
				// break frames
				top.location.href = url;
			} else {
				location.href = url
			}
		}
	}
	
	dojo.addOnLoad(function(){
		handleDateRange("today");
	});

	function handleDateRange(dateRange) {
		dojo.require('dojo.date');
		dojo.require('dojo.date.stamp');

		// Default to showing counts beginning at 00:00:00 this morning
		var fromDate = new Date();
		fromDate.setHours(0);
		fromDate.setMinutes(0);
		fromDate.setSeconds(0);
		fromDate.setMilliseconds(0);

		switch (dateRange) {
			case 'today':
				// Use the default
				break;
			case 'week':
				fromDate = dojo.date.add(fromDate, 'week', -1);
				break;
			case 'month':
				fromDate = dojo.date.add(fromDate, 'month', -1);
				break;
			case 'year':
				fromDate = dojo.date.add(fromDate, 'year', -1);
				break;
			case 'all-time':
				fromDate = new Date(0);
				break;
		}
		var fromDateString = encodeURIComponent(dojo.date.stamp.toISOString(fromDate, { milliseconds: true }));
		// The string needs to be encoded twice (%2B -> %252B) as it is decoded twice on the server
		fromDateString = encodeURIComponent(fromDateString);
		var xhrArgs = {
			url: "../ProcessInspector/rest/v1/processes/status/overview?fromDate=" + fromDateString,
			handleAs: "json",
			preventCache: true
		}

		var deferred = dojo.xhrGet(xhrArgs);
		if (deferred) {
			deferred.addCallback(function(data) {
				console.debug("got");
				console.debug(data);
				if (!data) {
					return Error("data is null");
				}

				// Update the status values
				var maxWidth = 0;
				var offset = 6; // margin width + border width
				for (var member in data.data.status) {
					var elem = dojo.byId(member+"_value");
					elem.innerHTML = data.data.status[member];
					var w = dojo.position(elem).w - offset;
					if (w > maxWidth) {
						maxWidth = w;
					}
				}

				// Update the status size
				for (var member in data.data.status) {
					var elem = dojo.byId(member+"_value");
					dojo.style(elem, "width", (maxWidth - offset) + "px");
				}

				// Remove the background highlighting from all the date ranges
				var elems = dojo.query("#dateRange span");
				dojo.forEach (elems, function(item) {
					if (dojo.hasClass(item, "dateRange_highlight")) {
						dojo.removeClass(item, "dateRange_highlight");
					}
				});
				// Set the background highlighting of the selected date range
				var elem = dojo.byId(dateRange);
				dojo.addClass(elem, "dateRange_highlight");

				// Clone the process apps template list
				elem = dojo.byId("process_apps_template");
				var clone = dojo.clone(elem);
				clone.id = "process_apps"
				// Set the cloned the list is be displayed
				dojo.style(clone, "display", "block");
				// Set the names and status images for the list items
				dojo.forEach (data.data.processApps, function(app) {
					var item = dojo.clone(clone.children[0]);
					item.children[0].innerHTML = app.name + ' (' + app.shortName + ')';

					switch (app.status) {
						case 'Executing':
							dojo.style(item, "background", "url(executing.png) no-repeat left top");
							break;
						case 'Failed':
							dojo.style(item, "background", "url(failed.png) no-repeat left top");
							break;
						case 'Suspended':
							dojo.style(item, "background", "url(suspended.png) no-repeat left top");
							break;
						case 'Late':
							dojo.style(item, "background", "url(late.png) no-repeat left top");
							break;
						case 'Active':
							dojo.style(item, "background", "url(active.png) no-repeat left top");
							break;
						case 'Completed':
							dojo.style(item, "background", "url(complete.png) no-repeat left top");
							break;
					}
					item.children[0].id = app.shortName;
					item.children[0].href = "javascript:launchInspector(duration, null,'" + app.shortName + "');";
					clone.appendChild(item);
				});
				// Remove the template list item
				clone.removeChild(clone.children[0]);
				if (data.data.processApps.length <= 0) {
					var none = document.createElement("li");
					dojo.style(none, "listStyleType", "none")
					var text = document.createTextNode('<bean:message key="none"/>');
					none.appendChild(text);
					clone.appendChild(none);
				}

				var parentNode = elem.parentNode;
				// Remove the old list
				parentNode.removeChild(parentNode.children[parentNode.children.length - 1]);
				// Add the new list of process apps
				parentNode.appendChild(clone);

				return data;
			});
			deferred.addErrback(function(data) {
				console.debug("error: %o", data);
				console.debug("xhrArgs: %o", xhrArgs);

				return data;
			});
		}
	}
</script>
</body>
</html>
