<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="msgs-init.jsp" %>
<%@ page import="java.security.SecureRandom" %>
<%@ page import="java.util.Random" %>
<%@ page import="com.lombardisoftware.servlet.CrossSiteRequestForgeryFilter" %>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<%
    String ua = request.getHeader( "User-Agent" );
    boolean isLombardiClient = ( ua != null && ua.indexOf( "lombardi-httpclient" ) != -1 );

// if this is a request from one of the automated clients we just return a simple page indicating that the client needs to login
    if (isLombardiClient || com.lombardisoftware.processadmin.server.PortalAdminHelper.isGWTService((String) request.getAttribute("javax.servlet.forward.servlet_path"))) {
%>LOGIN<%
} else { %>

<%
	Random secureRandom = new SecureRandom();
	session.setAttribute(CrossSiteRequestForgeryFilter.CSRF_TOKEN, Double.toString(secureRandom.nextDouble()));
%>

<html>
<head>
    <title><bean:message key="consoleTitle"/></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <META HTTP-EQUIV = "Pragma" CONTENT="no-cache" />
    <meta http-equiv="Cache-control" content="no-cache"/>
    <meta http-equiv="Cache-control" content="no-store"/>
    <link rel="stylesheet" type="text/css" href="<%= request.getContextPath() %>/login.css" media="screen, projection" />
    <script>
	    /* Check if the page is framed (top!=self) and set it to become the top frame 
		   therefore causing the browser to render the full window without the frame to
		   prevent the possible Cross Frame Scripting. 
		   The vulnerability only happens on early versions of IE browsers (IE 5.5 and 6.x) 
		*/
		if (self == top) {
	     document.documentElement.style.display = 'block';
	    } else {
	     top.location = self.location;
		}
    
        var allowSubmit = false;

        function doOnLoad() {
            document.login.j_username.focus();
            allowSubmit = true;
        }

        function setCookie(name, value, expires, path, domain, secure) {
            var curCookie = name + "=" + escape(value) +
                    ((expires) ? "; expires=" + expires.toGMTString() : "") +
                    ((path) ? "; path=" + path : "") +
                    ((domain) ? "; domain=" + domain : "") +
                    ((secure) ? "; secure" : "");
            document.cookie = curCookie;
        }

        function doOnSubmit() {
        <%--We want to make sure the applet has been loaded before we log in so that we can get the correct locale/time zone info from the client. If all else fails we assume GMT...--%>
/*	Moved setting of the timezoneoffset cookie to ProcessAdmin.jsp RTC 77109
		try {
                setCookie("ibm.bpm.timezoneOffset", new Date().getTimezoneOffset(), null, "/",null,<% if(request.isSecure()){%>true<%}else{%>null<%}%>);
            } catch(ex) {
                //do nothing
            } 
*/
            return true;
        }
    </script>
</head>
<body onLoad="doOnLoad()" id="pbody">
<div id="login-header">
    <div class="logo"></div>
</div>
<div id="login-body">
    <table cellpadding="0" cellspacing="0" width="100%">
        <tr>
            <td>&nbsp;</td>
            <td width="500">
                <div id="login-content">
                    <table id="content-header" cellspacing="0" cellpadding="0">
                        <tr>
                            <td id="content-header-left"></td>
                            <td id="content-title"><bean:message key="consoleLogin"/></td>
                            <td id="content-header-right"></td>
                        </tr>
                    </table> <div id="content-border">
                    <%String msgKey = request.getParameter("errorMessage");
                        if(msgKey == null){
                            msgKey = (String)session.getAttribute("errorMessage");
                        }%>
                    <%if(msgKey != null) {%>
                    <div id="login-error">
                        <bean:message key="loginError"/>
                    </div>
                    <%}%>
                    <form method="POST" action="j_security_check" name="login" onSubmit="return doOnSubmit()">
                        <div>
                            <table id="login-table" align="center">
                                <tr>
                                    <td><bean:message key="userName"/></td>
                                    <td><input style="width:130" type="text" name="j_username"></td>
                                </tr>
                                <tr>
                                    <td><bean:message key="password"/></td>
                                    <td><input style="width:130" type="password" name="j_password" autocomplete="off"></td>
                                </tr>
                                <tr><td colspan="2" align="center"><input type="submit" value='<bean:message key="login"/>'></td></tr>
                            </table>
                            <div id="login-copyright"><bean:message key="licensedMaterials"/></div>
                        </div>
                        <input type="hidden" name=<%=CrossSiteRequestForgeryFilter.CSRF_TOKEN%> value=<%= session.getAttribute(CrossSiteRequestForgeryFilter.CSRF_TOKEN)%>> 
                    </form>
                </div>
                </div>
            </td>
            <td>&nbsp;</td>
        </tr>
    </table>
</div>
</body>
</html>
<% } %>

